//
// main.cpp - smplcalcvÕC
//
#include <iostream>
#include <stack>     // stackg
#include <cmath>     // atof()̂
#include <cstdlib>   // atof()̂
#include <cctype>    // isdigit()̂
#include "util.h"

using namespace std;

enum tokenType { Value, Plus, Minus, Mult, Divide };
typedef tokenType TokenType;

class Token {
    double value;
    TokenType type;
public:
    Token () {};
    Token (double v, TokenType t) {
        value = v;
        type = t;
    };
    Token (double v) {
        value = v;
        type = Value;
    };
    Token (TokenType t) {
        value = 0.0;
        type = t;
    };
    double getValue() { return value; };
    TokenType getType() { return type; };
};

int getTop2Elem(stack<Token> &stck, Token *a, Token *b);
void printstack(stack<Token>);
int isNumberString(string s);
void syntaxError();

int main(int argc, char *argv[])
{
    stack<Token> stck;
    Token tokv, tokop;
    string s;
    double a, b;

    while (true)
    {
        cout << "->";  // vvgo͂
        cin >> s;      // [U[̃L[͂󂯎
        if ( s.length() == 0) // s̓G[Ƃ݂ȂȂ
            continue;
        // 񂪁uquitvł΃[v𔲂
        if ( compareIgnCase(s, "quit") )
            break;
        // uprintstackvłΌ݂̃X^bN̓eo͂
        if ( compareIgnCase(s, "printstack") ) {
            printstack(stck);
            continue;
        }

        char c = s[0];      // ̐擪̕o
        if (s.size() == 1 &&  !isdigit((int)c)) { // ZqƂ݂Ȃ
            switch(c) {
            case '+': // Z
                stck.push( Token (Plus));
                break;
            case '-': // Z
                stck.push( Token (Minus));
                break;
            case '*': // Z
                stck.push( Token (Mult));
               break;
            case '/':  // ZiZj
                stck.push( Token (Divide));
                break;
            default:
                // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
                syntaxError();
                break;
            }
            continue;
        } // fi
        // l͂ꂽׂ
        if ( isNumberString(s) ) {
            if (stck.size() < 2) { 
                // lX^bNɃvbV
                stck.push( Token(atof(s.c_str())) );
            } else { 
                // X^bNɉZqƐĂ͂
                getTop2Elem(stck, &tokop, &tokv);
                a = atof(s.c_str());
                b = tokv.getValue();
                switch (tokop.getType()) {
                    case Plus: // Z
                        cout << a + b << endl;
                        stck.push( Token ( a + b ) );
                        break;
                    case Minus: // Z
                        cout << b - a << endl;
                        stck.push( Token ( b - a ) );
                        break;
                    case Mult: // Z
                        cout << a * b << endl;
                        stck.push( Token ( a * b ) );
                        break;
                    case Divide:  // ZiZj
                        cout << b / a << endl;
                        stck.push( Token ( b / a ) );
                        break;
                    default:
                        // +A-A/A*̂łȂ΃G[Ƃ݂Ȃ
                        syntaxError();
                        break;
                 }  // hctiws
            }// fi
        } else { 
            syntaxError();
        }
    }
    
    return 0;
}

// X^bNŏ㕔̗vfo
int getTop2Elem(stack<Token> &stck, Token *a, Token *b)
{
    if (stck.size() < 2) {
        cout << "Iyh܂" << endl;
        return -1;
    }
    *a = stck.top();
    stck.pop();
    *b = stck.top();
    stck.pop();

    return 0;
}

string TokenTypeName[] = { "Value", "Plus", "Minus", "Mult", "Divide" };

// X^bN̓eׂďo͂
void printstack(stack<Token> stck)
{
    stack<Token> tmpstck; // X^bN̓eo͂ۂɃf[^
                           // ꎞIɕۑ邽߂̕ϐ
    tmpstck = stck;
    cout << "---  stack top   ---" << endl;
    int n = (int)tmpstck.size();
    for(int i=0; i<n; i++) {
        Token t = tmpstck.top();
        cout << TokenTypeName[t.getType()] << ":" << t.getValue() << endl;
        tmpstck.pop();
    }
    cout << "--- stack bottom ---" << endl;
}


