//
// main.cpp
//
#include "util.h"

using namespace std;

enum tokenType { Value, Plus, Minus, Mult, Divide, Assign,
                 LParen, RParen, Symbol, Invalid, Start };
typedef tokenType TokenType;

class Token {
    string symbol;
    double value;
    TokenType type;
public:
    // RXgN^
    Token () {};
    Token (double v, TokenType t) {
        value = v;
        type = t;
    };
    Token (double v) {
        value = v;
        type = Value;
    };
    Token (string s) {
        symbol = s;
        type = Symbol;
    };
    Token (TokenType t) {
        value = 0.0;
        type = t;
    };
    string getSymbol() { return symbol; };
    double getValue() { return value; };
    TokenType getType() { return type; };
};

Token *getToken(string s);
bool isOparator(char c);
void printToken(Token *tok);
Token prevTok;
bool isStartToken(TokenType tt);
bool isParen(char c);

int main(int argc, char *argv[])
{
    string s;
    Token *tok = new Token();
    bool disptoken = true;   // falseɂƉ\Ȃ

    while (true)
    {
        char buff[256];
        cout << "->";  // vvgo͂
        cin.getline(buff, 256);     // [U[̃L[͂󂯎
        s = trim( string(buff) );              // Ő󔒂菜
        if ( s.length() == 0) // s̓G[Ƃ݂ȂȂ
            continue;
        // 񂪁uquitvł΃[v𔲂B
        if ( compareIgnCase(s, "quit") )
            break;

        // Õg[NƂāuŏ̃g[NvۑĂB
        prevTok = Token(Start);
        // ŏ̕g[Nɐ؂蕪
        tok = getToken( s );
        while( tok != NULL ) {
            if (disptoken)
                printToken(tok);
            prevTok = *tok;
            // c̕g[Nɐ؂蕪
            tok = getToken( "" );
        }
    }
    return 0;
}

// g[Nɐ؂蕪
Token *getToken(string s)
{
    static string srcstr;
    string tokenstr;

    // ̑Ő󔒂
    string ss = trimStart(s);
    srcstr += ss; 
    if (srcstr.length() == 0)
        return NULL;

    int pos = 0;  // ݂̕ʒuۑ
    char c = srcstr[pos++];  // 擪̕
    char c2 = 0;             // 擪̕
    if (srcstr.length()>2)
        c2 = srcstr[pos];   // 擪̕
    TokenType ptt = prevTok.getType();
    if ( c == '-' && !isStartToken(ptt) ) {  // -Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Minus ) ;
    }
    if ( c == '+' && !isStartToken(ptt) ) {  // +Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Plus ) ;
    }
    if ( c == '/') {                // /Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Divide ) ;
    }
    if ( c == '*') {                // *Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Mult ) ;
    }
    if ( c == '=') {                // =Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Assign ) ;
    }
    if ( c == ')') {                // )L
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( RParen ) ;
    }
    if ( c == '(') {                // (L
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( LParen ) ;
    }
    if ( c == '-' ||  c == '+' ||  c == '.' || isdigit(c) ) { // l̐擪
        tokenstr = c;
        while (true) {
            if (srcstr.length() == pos) {  // ͕̏I
                srcstr = "";
                return new Token( atof(tokenstr.c_str()) );
            }
            c = srcstr[pos++];
            if ( c == '.' || isdigit(c) )
                tokenstr += c;
            else {
                --pos;
                int len = srcstr.length() - pos;
                srcstr = srcstr.substr(pos, len);
                return new Token( atof(tokenstr.c_str()) );
            }
        }
    }
    // O
    tokenstr = c;
    while (true) {
        if (srcstr.length() == pos) {  // ͕̏I
            srcstr = "";
            return new Token( tokenstr );
        }
        c = srcstr[pos++];
        if ( c == ' ' || isOparator(c)  || isParen(c) ) {
            --pos;
            int len = srcstr.length() - pos;
            srcstr = srcstr.substr(pos, len);
            return new Token( tokenstr );
        } else {
            tokenstr += c;
        }
    }
    return new Token(Invalid);
}

bool isOparator(char c)
{
    if (c == '-' || c == '+')
        return true;
    if (c == '*' || c == '/')
        return true;
    if (c == '=')
        return true;
    return false;
}

bool isParen(char c){
    if (c == '(' || c == ')')
        return true;
    return false;
}

bool isStartToken(TokenType tt)
{
    if (tt == Start)
        return true;
    if (tt == LParen)
        return true;
    if (tt == Assign)
        return true;
    return false;
}

string TokenTypeName[] = { "Value", "+(Plus)", "-(Minus)", 
                           "*(Mult)", "/(Divide)", "=(Assign)",
                           "LParen", "RParen", "Symbol" };
void printToken(Token *ptok)
{
    if (ptok->getType() == Value) {
        cout << "Value:" << ptok->getValue() << endl;
        return;
    }
    if (ptok->getType() == Symbol) {
        cout << "Symbol:" << ptok->getSymbol() << endl;
        return;
    }
    if (ptok->getType() == LParen) {
        cout << "Paren:(" << endl;
        return;
    }
    if (ptok->getType() == RParen) {
        cout << "Paren:)" << endl;
        return;
    }
    cout << "Oparator:" << TokenTypeName[ptok->getType()] << endl;
}