// 
// gettoken.cpp
//
#include "gettoken.h"
#include "util.h"

using namespace std;

string TokenTypeName[] = { "Value", "+(Plus)", "-(Minus)", 
                           "*(Mult)", "/(Divide)", "=(Assign)",
                           "LParen", "RParen", "Symbol", "Variable",
                           "Invalid", "Start"};

// g[Nɐ؂蕪
Token *getToken(string s)
{
    static string srcstr;
    string tokenstr;

    // ̑Ő󔒂
    string ss = trimStart(s);
    srcstr += ss;
    s = trim(srcstr);
    srcstr = s;
    if (srcstr.length() == 0)
        return NULL;

    int pos = 0;  // ݂̕ʒuۑ
    char c = srcstr[pos++];  // 擪̕
    char c2 = 0;             // 擪̕
    if (srcstr.length()>2)
        c2 = srcstr[pos];   // 擪̕
    if ( c == '-' && !(prevTok.isStartToken()) ) {  // -Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Minus ) ;
    }
    if ( c == '+' && !(prevTok.isStartToken()) ) {  // +Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Plus ) ;
    }
    if ( c == '/') {                // /Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Divide ) ;
    }
    if ( c == '*') {                // *Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Mult ) ;
    }
    if ( c == '=') {                // =Zq
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( Assign ) ;
    }
    if ( c == ')') {                // )L
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( RParen ) ;
    }
    if ( c == '(') {                // (L
        srcstr = srcstr.substr(1, srcstr.length()-1);
        return new Token ( LParen ) ;
    }
    if ( c == '-' ||  c == '+' ||  c == '.' || isdigit(c) ) { // l̐擪
        tokenstr = c;
        while (true) {
            if (srcstr.length() == pos) {  // ͕̏I
                srcstr = "";
                return new Token( atof(tokenstr.c_str()) );
            }
            c = srcstr[pos++];
            if ( c == '.' || isdigit(c) )
                tokenstr += c;
            else {
                --pos;
                int len = srcstr.length() - pos;
                srcstr = srcstr.substr(pos, len);
                return new Token( atof(tokenstr.c_str()) );
            }
        }
    }
    // O
    tokenstr = c;
    while (true) {
        if (srcstr.length() == pos) {  // ͕̏I
            srcstr = "";
            return new Token( tokenstr );
        }
        c = srcstr[pos++];
        if ( c == ' ' || isOparator(c) || isParen(c)) {
            --pos;
            int len = srcstr.length() - pos;
            srcstr = srcstr.substr(pos, len);
            return new Token( tokenstr );
        } else {
            tokenstr += c;
        }
    }
    return new Token(Invalid);
}

bool Token::isStartToken()
{
    if (type == Start)
        return true;
    if (type == LParen)
        return true;
    if (type == Assign)
        return true;
    return false;
}

void Token::printToken()
{
    if (!disptoken)
        return;

    if (type == Value) {
        cout << "Value:" << value << endl;
        return;
    }
    if (type == Symbol) {
        cout << "Symbol:" << symbol << endl;
        return;
    }
    if (type == LParen) {
        cout << "Paren:(" << endl;
        return;
    }
    if (type == RParen) {
        cout << "Paren:)" << endl;
        return;
    }
    cout << "Oparator:" << TokenTypeName[type] << endl;
}