// 
// gettoken.h
//
#ifndef GETTOKEN_H
#define GETTOKEN_H
#include <iostream>
#include <algorithm>
#include <string>
#include <cctype>
#include <stack>

using namespace std;

typedef enum tokenType { Start, Invalid, Nothing, NomoreToken,
    Value, Variable, Symbol, StrLiteral, LParen, RParen, Comma,
    Mult, Divide, Plus, Minus,
    Smaller, Greater, Equal, NotEqual, Assign, 
    Cmd, End, Print, Println, Printspc, 
    Call, Sub, Endsub, If, Then, Else, Endif, For, To, Next } TokenType;
typedef enum tokenPos { Top, AfterLParen, AfterAssign, Middle, EndToken } TokenPos;

class Token {
    TokenType type;    // g[N̎
    string symbol;     // g[N̖OAϐA܂͕
    double value;      // g[Nl̂Ƃ̒l
    TokenPos position; // ̃g[N̍s̒̈ʒu
public:
    // RXgN^
    Token () { value = 0.0; };
    Token (TokenType t, string s, double v, TokenPos pos = Middle) {
        type = t;
        symbol = s;
        value = v;
        position = pos;
    };
    Token (TokenType t, double v, TokenPos pos = Middle) {
        type = t;
        value = v;
        position = pos;
    };
    Token (double v, TokenPos pos = Middle) {
        value = v;
        type = Value;
        position = pos;
    };
    Token (TokenType t, TokenPos pos = Middle) {
        type = t;
        value = 0.0;
        position = pos;
    };
    Token (TokenType t, string s, TokenPos pos = Middle) {
        type = t;
        symbol = s;
        value = 0.0;
        position = pos;
    };
    Token (string s, TokenPos pos = Middle) {
        symbol = s;
        type = Symbol;
        value = 0.0;
        position = pos;
    };
    TokenType getType() { return type; };
    void setType(TokenType t) { type =t; };
    string getSymbol() { return symbol; };
    double getValue() { return value; };
    void setValue(double v) { value = v; };
    TokenPos getPosition() { return position; };
    bool isStartToken();
    void printToken();

};

extern vector < Token > TokenList;
extern bool DispToken;    // trueŃg[N\
extern bool DispStack;    // trueŃX^bN\

// 擪̃g[NoĕԂig[N̗vf1)
Token getNextToken(vector < Token > & tknList);
void backToken(Token tok, vector < Token > & tknList); // g[N߂
TokenType get1stTokenType(string src); // \[Xsrc̍ŏ̃g[N^Cv擾
void backToken(Token tok);  // g[N߂
Token getTokenN(int n, vector < Token > tknList);   // NԖڂ̃g[N擾
int getTokenList(string s, vector < Token > & tknList);
Token getToken(string s);
// g[ÑXgo͂
void dispTokenList(vector < Token > tknList, string name);
void printTokenValOrLiteral(Token tt, bool crlf=false);

#endif
